// ***********************************************************************
// VISUAL MARRIAGE Applet
//
// Visualizes the algorithm for finding a man-optimal stable marriage.
// The simulated algorithm is the one of Gale and Shapley.
//
// by Rolf Bruderer, Oct 2003
// ***********************************************************************

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.Applet;
import java.awt.geom.*;
//import java.awt.image.BufferedImage;


public class VisualMarriage 
   // Visual Marriage Applet.
   // Can also be opened as normal Java-Application.
   // Just initializes and runs a Frame-Object.

extends Applet 

implements ActionListener 

{

   private static MainWindow main_window = null;


   public ImageIcon getImageIcon(String filename) {
      return new ImageIcon (VisualMarriage.class.getResource(filename));
   }


   public void init () {
	try {
	 setLayout (new GridLayout (1, 1));
	 setBackground(Color.black);
	 JButton startButton = new JButton ("Start VISUAL MARRIAGE Applet");
	 startButton.setBackground(new Color(64, 64, 192));
	 startButton.setForeground(Color.white);
	 startButton.setMargin(new Insets(0,0,0,0));
	 startButton.setPreferredSize(new Dimension(200, 25));
	 startButton.setSize(200, 25);
	 startButton.addActionListener (this);
	 add (startButton);	
	 setVisible (true);	
	 main_window = null;
	}
	catch (Exception e) {
		e.printStackTrace();
	}
   }


   public void actionPerformed(ActionEvent e) {
		if (main_window == null) {
			main_window = new MainWindow ();
	    	main_window.addWindowListener(new WindowAdapter() {
            	public void windowClosing(WindowEvent evt) {
              		main_window = null;
            	}
        	});
		}
		else {
			main_window.bringWindowsToFront();
		}
   }

   public static void main(String [] args) {
      main_window = new MainWindow();
      main_window.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent evt) {
			main_window = null;
          	System.exit(0);
        }
      });
   }
   
}